require "octopando/version"
require 'colorize'
require 'git'
require 'jira'
require 'keychain'
require 'thor'
require 'word_wrap'

module Octopando

  class KeyChainError < StandardError
  end
  def self.git
      @git ||= Git.open(Dir.pwd)
  end

  def self.jira
    @jira ||= JiraClient.from_keychain
  end

end

require "octopando/cli"
require "octopando/jira_client"


JIRA::Resource::Issue.class_eval do

  def has_branch?
    branch != nil
  end

  def branch
    Octopando.git.branches.local.select do |git_branch|
      git_branch.name[/#{self.key}$/]
    end.first
  end

  def checkout(type='issue')
    Octopando.git.branch("#{type}/#{self.key}").checkout
  end

  def move_to_in_progress
    transition = self.transitions.build
    id = transitions.all.first {|e| puts e.name == "To In Progress" }.id
    transition.save!("transition" => {"id" => id})
  end
end
